//
// Copyright (c) 2001, Junzo SATO. All rights reserverd.
//
package MathSocketTerminal;

import java.awt.*;
import java.awt.event.*;

// TCP/IP Connection
import java.io.*;
import java.net.*;
import java.util.*;

import com.wolfram.jlink.*;

public class MathSocketReceiverThread extends Thread {
	InputStream inStream = null;
	BufferedInputStream in = null;
	SocketListener listener = null;
	
	public MathSocketReceiverThread(Socket clientSocket, SocketListener l) {
		try {
			inStream = clientSocket.getInputStream();
			in = new BufferedInputStream(clientSocket.getInputStream());
		} catch (IOException e1) {
			return;
		}
		
		listener = l;
		
		start();
	}
	
	public void echo(String str) {
		//------------------------------
		// CALL MATHEMATICA
		if (listener != null) {
			if (listener.hasHandler()) {
				// put string to mathematica
				listener.stringArrived(str);
				// get result from mathematica
				Expr result = listener.getResult();
				if (result != null) {
					// we need not to use this result
					result.dispose();
				}
				listener.disposeResult();
			}
		}
		//------------------------------
	}

	public void setSocketListener(SocketListener l) {
		listener = l;
	}

	public void run() {
		int n = 0;
		String str = null;
		while (true) {
			try {
				// because the telnet server doesn't send a string terminated with CRLF,
				// using byte array is better.
				n = in.available();
				if (n <= 0) continue;
				
				byte[] buff = new byte[n];
				n = in.read(buff);
				if (n <= 0) continue;
				
				ByteArrayOutputStream ba = new ByteArrayOutputStream(n);
				ba.write(buff,0,n);
				str = ba.toString();
				str = str.trim();
				//------------------------------
				// CALL MATHEMATICA
				if (listener != null) {
					if (listener.hasHandler()) {
						// put string to mathematica
						listener.stringArrived(str);
						// get result from mathematica
						Expr result = listener.getResult();
						if (result != null) {
							// we need not to use this result
							result.dispose();
						}
						listener.disposeResult();
					}
				}
				//------------------------------
				buff = null;
			} catch (IOException e3) {

			}
				
			try {
				Thread.sleep(1);
			} catch (InterruptedException e1) {
			
			}
		}
	}
}