//
// Copyright (c) 2001, Junzo SATO. All rights reserverd.
//

package MathSocketTerminal;

import com.wolfram.jlink.*;

public class SocketListener extends MathListener {
	boolean having = false;
	Expr result = null;
	
	public Expr getResult() {
		return result;
	}
	
	public void disposeResult() {
		if (result != null) {
			result.dispose();
			result = null;
		}
	}
	
	public boolean hasHandler() {
		return having;
	}
	
	// because we don't check the existence of handler(s) inside this class,
	// the user should set the flag after setting/removing a handler using 
	// setHasHandler(true/false)
	public void setHasHandler(boolean f) {
		having = f;
	}
	
	//------------------------------------
	public SocketListener() {
		super();
	}

	public SocketListener(KernelLink ml) {
		super(ml);
	}

	public SocketListener(String func) {
		this();
		setHandler("stringArrived", func);
		setHasHandler(true);
	}

	//------------------------------------
	public void stringArrived(String str) {
		if (having == false) return;
		
		if (result != null) {
			result.dispose();
		}

		result = callMathHandler("stringArrived", new Object[]{str});
	}
}