(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      8512,        358]*)
(*NotebookOutlinePosition[      9357,        385]*)
(*  CellTagsIndexPosition[      9313,        381]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["MathSocketTerminal", "Title"],

Cell["Copyright \[Copyright] 2001, Junzo SATO. All rights reserverd.", "Text"],

Cell[CellGroupData[{

Cell["Load J/Link", "Section"],

Cell[BoxData[
    \(<< JLink`\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(InstallJava[]\)], "Input"],

Cell[BoxData[
    \(LinkObject["JLink", 3, 2]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Load MathSocketTerminal", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    \(terminal = 
      JavaNew["\<MathSocketTerminal.MathSocketTerminal\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "MathSocketTerminal.MathSocketTerminal"] \[RightGuillemet]\),
      JLink`Objects`JavaObject1925170331649]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create SocketListener", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    \(socketListener = 
      JavaNew["\<MathSocketTerminal.SocketListener\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "MathSocketTerminal.SocketListener"] \[RightGuillemet]\),
      JLink`Objects`JavaObject1925843648513]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(handlerSocketListener[s_] := 
      Module[\[IndentingNewLine]{}, \[IndentingNewLine]Print[
          s]\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(socketListener@
      setHandler["\<stringArrived\>", 
        ToString[handlerSocketListener]]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(socketListener@setHasHandler[True]\)], "Input"],

Cell[BoxData[
    \(terminal@setSocketListener[socketListener]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Start Session", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ShareFrontEnd[]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["To Telnet Server", "Section"],

Cell["\<\
Setup remote server so that it can receive message from this \
terminal.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"terminal", "@", 
      RowBox[{"connectToServer", "[", 
        RowBox[{
          StyleBox["\"\<192.168.0.1\>\"",
            FontColor->RGBColor[0, 0, 1]], ",", "23"}], "]"}]}]], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(terminal@startSession[]\)], "Input"],

Cell[BoxData[
    \("login:"\)], "Output"]
}, Open  ]],

Cell["\<\
The message is sent only. The sender does not recieve the answer \
from the server.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(terminal@sendRequest["\<jsato\>"]\)], "Input"],

Cell[BoxData[
    \("jsato"\)], "Print"],

Cell[BoxData[
    \("Password:"\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(terminal@sendRequest["\<secret\>"]\)], "Input"],

Cell[BoxData[
    \("Last login: Fri May 25 14:58:05 from 133.95.88.203"\)], "Print"],

Cell[BoxData[
    \("[jsato@mail0 jsato]$"\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(terminal@sendRequest["\<ls -al\>"]\)], "Input"],

Cell[BoxData[
    \("ls -al"\)], "Print"],

Cell[BoxData[
    \("total 22\r\ndrwx------   2 jsato    jsato        1024 May 23 11:46 ./\r\
\ndrwxr-xr-x   8 root     root         4096 May 23 11:44 ../\r\n-rw-r--r--   \
1 jsato    jsato        3785 May 23 11:44 .Xdefaults\r\n-rw-------   1 jsato  \
  jsato         274 May 25 14:58 .bash_history\r\n-rw-r--r--   1 jsato    \
jsato          24 May 23 11:44 .bash_logout\r\n-rw-r--r--   1 jsato    jsato  \
       248 May 23 11:44 .bash_profile\r\n-rw-r--r--   1 jsato    jsato        \
1233 May 23 11:44 .bashrc\r\n-rw-r--r--   1 jsato    jsato          72 May 23 \
11:44 .elvisrc\r\n-rw-r--r--   1 jsato    jsato         193 May 23 11:44 \
.exrc\r\n-rw-r--r--   1 jsato    jsato          57 May 23 11:44 .inputrc\r\n\
-rw-r--r--   1 jsato    jsato          37 May 23 11:44 .less\r\n-rw-------   \
1 jsato    jsato           0 May 23 11:44 .rhosts\r\n-rw-r--r--   1 jsato    \
jsato         263 May 23 11:44 .vimrc\r\n-rwxr-xr-x   1 jsato    jsato        \
1527 May 23 11:44 .xinitrc*\r\n-rwxr-xr-x   1 jsato    jsato         264 May \
23 11:44 .xsession*\r\n[jsato@mail0 jsato]$"\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(terminal@sendRequest["\<exit\>"]\)], "Input"],

Cell[BoxData[
    \("exit"\)], "Print"],

Cell[BoxData[
    \("logout\r\n'network': unknown terminal type."\)], "Print"]
}, Open  ]],

Cell[BoxData[
    \(terminal@disconnectFromServer[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["To Unconnectable Telnet Server", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"terminal", "@", 
      RowBox[{"connectToServer", "[", 
        RowBox[{
          StyleBox["\"\<192.168.0.2\>\"",
            FontColor->RGBColor[0, 0, 1]], ",", "23"}], "]"}]}]], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(terminal@startSession[]\)], "Input"],

Cell[BoxData[
    \("Remote TELNET access to Cache unavailable on Single User Systems!"\)], \
"Output"]
}, Open  ]],

Cell[BoxData[
    \(terminal@disconnectFromServer[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["To Time Server", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"terminal", "@", 
      RowBox[{"connectToServer", "[", 
        RowBox[{
          StyleBox["\"\<192.168.0.2\>\"",
            FontColor->RGBColor[0, 0, 1]], ",", "13"}], "]"}]}]], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(terminal@startSession[]\)], "Input"],

Cell[BoxData[
    \("17:09:27 2001/05/25"\)], "Print"]
}, Open  ]],

Cell[BoxData[
    \(terminal@disconnectFromServer[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["To Text Server", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"terminal", "@", 
      RowBox[{"connectToServer", "[", 
        RowBox[{
          StyleBox["\"\<192.168.0.3\>\"",
            FontColor->RGBColor[0, 0, 1]], ",", "2001"}], "]"}]}]], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(terminal@startSession[]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(terminal@sendRequest["\<Hello:-)\>"]\)], "Input"],

Cell[BoxData[
    \("HELLO:-)"\)], "Print"]
}, Open  ]],

Cell[BoxData[
    \(terminal@disconnectFromServer[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Quit", "Section"],

Cell[BoxData[
    \(UnshareFrontEnd[]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UninstallJava[]\)], "Input"],

Cell[BoxData[
    \("JLink"\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(Quit[]\)], "Input"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{700, 634},
WindowMargins->{{125, Automatic}, {Automatic, 5}},
MacintoshSystemPageSetup->"\<\
0080001804P000000bH2;oo^onh3>091P0<5NP?P0040009H0UP000006SXB=000
0000I0000000000000000BL?00400@0000000000000004e<BE00000000000000
000000006H4J0001000000RP001A00H0\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 35, 0, 98, "Title"],
Cell[1777, 53, 78, 0, 30, "Text"],

Cell[CellGroupData[{
Cell[1880, 57, 30, 0, 50, "Section"],
Cell[1913, 59, 42, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[1980, 64, 46, 1, 27, "Input"],
Cell[2029, 67, 59, 1, 26, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2137, 74, 42, 0, 50, "Section"],

Cell[CellGroupData[{
Cell[2204, 78, 103, 2, 27, "Input"],
Cell[2310, 82, 194, 3, 26, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2553, 91, 40, 0, 50, "Section"],

Cell[CellGroupData[{
Cell[2618, 95, 105, 2, 27, "Input"],
Cell[2726, 99, 190, 3, 26, "Output"]
}, Open  ]],
Cell[2931, 105, 157, 3, 75, "Input"],

Cell[CellGroupData[{
Cell[3113, 112, 128, 3, 43, "Input"],
Cell[3244, 117, 38, 1, 26, "Output"]
}, Open  ]],
Cell[3297, 121, 67, 1, 27, "Input"],
Cell[3367, 124, 75, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3479, 130, 32, 0, 50, "Section"],

Cell[CellGroupData[{
Cell[3536, 134, 48, 1, 27, "Input"],
Cell[3587, 137, 35, 1, 26, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3671, 144, 35, 0, 50, "Section"],
Cell[3709, 146, 96, 3, 30, "Text"],

Cell[CellGroupData[{
Cell[3830, 153, 216, 5, 27, "Input"],
Cell[4049, 160, 38, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4124, 166, 56, 1, 27, "Input"],
Cell[4183, 169, 42, 1, 26, "Output"]
}, Open  ]],
Cell[4240, 173, 107, 3, 30, "Text"],

Cell[CellGroupData[{
Cell[4372, 180, 66, 1, 27, "Input"],
Cell[4441, 183, 40, 1, 22, "Print"],
Cell[4484, 186, 44, 1, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4565, 192, 67, 1, 27, "Input"],
Cell[4635, 195, 85, 1, 22, "Print"],
Cell[4723, 198, 55, 1, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4815, 204, 67, 1, 27, "Input"],
Cell[4885, 207, 41, 1, 22, "Print"],
Cell[4929, 210, 1096, 14, 502, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6062, 229, 65, 1, 27, "Input"],
Cell[6130, 232, 39, 1, 22, "Print"],
Cell[6172, 235, 78, 1, 52, "Print"]
}, Open  ]],
Cell[6265, 239, 64, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6366, 245, 49, 0, 50, "Section"],

Cell[CellGroupData[{
Cell[6440, 249, 216, 5, 27, "Input"],
Cell[6659, 256, 38, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6734, 262, 56, 1, 27, "Input"],
Cell[6793, 265, 103, 2, 26, "Output"]
}, Open  ]],
Cell[6911, 270, 64, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7012, 276, 33, 0, 50, "Section"],

Cell[CellGroupData[{
Cell[7070, 280, 216, 5, 27, "Input"],
Cell[7289, 287, 38, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7364, 293, 56, 1, 27, "Input"],
Cell[7423, 296, 54, 1, 22, "Print"]
}, Open  ]],
Cell[7492, 300, 64, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7593, 306, 33, 0, 50, "Section"],

Cell[CellGroupData[{
Cell[7651, 310, 218, 5, 27, "Input"],
Cell[7872, 317, 38, 1, 26, "Output"]
}, Open  ]],
Cell[7925, 321, 56, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[8006, 326, 69, 1, 27, "Input"],
Cell[8078, 329, 43, 1, 22, "Print"]
}, Open  ]],
Cell[8136, 333, 64, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8237, 339, 23, 0, 50, "Section"],
Cell[8263, 341, 50, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[8338, 346, 48, 1, 27, "Input"],
Cell[8389, 349, 41, 1, 26, "Output"]
}, Open  ]],
Cell[8445, 353, 39, 1, 27, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

